if( !EmojiPrint ){
  var EmojiPrint = {};
}
EmojiPrint.Carrier = {
  docomo: {
    name: 'docomo',
    'iso-2022-jp': function(c1, c2){
      return undefined;
    },
    'shift_jis': function( c1, c2 ){
      var value = c1.charCodeAt()*256+c2.charCodeAt();
      if( (value >= 63647 && value <= 63740 ) || (value >= 63808 && value <= 63996 ) ){
	return '<img style="vertical-align:text-bottom;" src="chrome://emojiprint/content/emoji/i/'+value+'.gif">';
      }
      return undefined;
    },
    filter: function( body ){
      return body;
    }
  },
  au: {
    name: 'au',
    'iso-2022-jp': function(c1, c2){
      if( c1.charCodeAt() >= 117 ){
	var jiscode = c1.charCodeAt().toString(16).toUpperCase() +
                      c2.charCodeAt().toString(16).toUpperCase();
	if( EmojiPrint.Carrier.au['iso-2022-jp'].mapping[jiscode] ){
	  return '<img style="vertical-align:text-bottom;" src="chrome://emojiprint/content/emoji/e/'+EmojiPrint.Carrier.au['iso-2022-jp'].mapping[jiscode]+'.gif">';
	}
      }
      return undefined;
    },
    'shift_jis': function( c1, c2 ){
      return undefined;
    },
    filter: function( body ){
      return body;
    }

  },
  softbank: {
    name: 'softbank',
    'iso-2022-jp': function(c1, c2){
      return undefined;
    },
    'shift_jis': function( c1, c2 ){
      var v1 = c1.charCodeAt();
      var v2 = c2.charCodeAt();
      if( v1 >= 247 && v2 <= 251 ){
      	var res = 0;
	switch(v1 ){
	case 247:
	  if( v2 >= 65 && v2 <= 126 ){
	    res = 17697 + v2 - 65;
	  }else if( v2 >= 128 && v2 <= 155 ){
	    res = 17759 + v2 - 128;
	  }else if( v2 >= 161 && v2 <= 243 ){
	    res = 17953 + v2 - 161;
	  }
	  break;
	case 249:
	  if( v2 >= 65 && v2 <= 126 ){
	    res = 18209 + v2 - 65;
	  }else if( v2 >= 128 && v2 <= 155 ){
	    res = 18271 + v2 - 128;
	  }else  if( v2 >= 161 && v2 <= 243 ){
	    res = 20257+ v2 - 161;
	  }
	  break;
	case 251:
	  if( v2 >= 65 && v2 <= 126 ){
	    res = 20513 + v2 - 65;
	  }else if( v2 >= 128 && v2 <= 141 ){
	    res = 20575 + v2 - 128;
	  }else  if( v2 >= 161 && v2 <= 215 ){
	    res = 20769+ v2 - 161;
	  }
	  break;
	}
	if( res ){
	  return '<img style="vertical-align:text-bottom;" src="chrome://emojiprint/content/emoji/s/'+res+'.gif">';
	}
      }
      return undefined;
    },
    filter: function( body ){
      return body;
    }
  },
  willcom: {
    name: 'willcom',
    'iso-2022-jp': function(c1, c2){
      return undefined;
    },
    'shift_jis': function( c1, c2 ){
      return undefined;
    },
    filter: function( body ){
      return body.replace(/\<\#([^\>]+)\>/g, function(p, name){
	name = name.replace(/\//g, '_').replace(/\!/g,'E').replace(/\?/g,'Q');
	return '<img style="vertical-align:text-bottom;" src="chrome://emojiprint/content/emoji/w/'+name+'.gif">';
      });
    }
  }
};

EmojiPrint.Carrier.au['iso-2022-jp'].mapping = {
  "753A": "1",
  "753B": "2",
  "753C": "3",
  "7729": "4",
  "772A": "5",
  "772B": "6",
  "772C": "7",
  "772D": "8",
  "772E": "9",
  "772F": "10",
  "7730": "11",
  "757A": "12",
  "766C": "13",
  "7776": "14",
  "753F": "15",
  "7540": "16",
  "7731": "17",
  "7732": "18",
  "7733": "19",
  "7734": "20",
  "7735": "21",
  "7736": "22",
  "7737": "23",
  "7738": "24",
  "7777": "25",
  "7778": "26",
  "7779": "27",
  "777A": "28",
  "777B": "29",
  "777C": "30",
  "777D": "31",
  "777E": "32",
  "777F": "33",
  "7780": "34",
  "7781": "35",
  "7782": "36",
  "7783": "37",
  "7784": "38",
  "7785": "39",
  "7786": "40",
  "7787": "41",
  "7788": "42",
  "7789": "43",
  "7541": "44",
  "7573": "45",
  "7833": "46",
  "7542": "47",
  "766D": "48",
  "775D": "49",
  "7655": "50",
  "7834": "51",
  "757B": "52",
  "766E": "53",
  "774B": "54",
  "774C": "55",
  "775E": "56",
  "7778": "57",
  "7535": "58",
  "775F": "59",
  "7543": "60",
  "774D": "61",
  "774E": "62",
  "774F": "63",
  "7750": "64",
  "757C": "65",
  "7751": "66",
  "7760": "67",
  "7656": "68",
  "7544": "69",
  "7752": "70",
  "7753": "71",
  "766F": "72",
  "7754": "73",
  "763A": "74",
  "7521": "75",
  "7525": "76",
  "752F": "77",
  "763B": "78",
  "782E": "79",
  "7657": "80",
  "7755": "81",
  "7756": "82",
  "7555": "83",
  "782F": "84",
  "7835": "85",
  "7658": "86",
  "7779": "87",
  "7757": "88",
  "7758": "89",
  "7770": "90",
  "7556": "91",
  "7761": "92",
  "7836": "93",
  "7670": "94",
  "7545": "95",
  "7574": "96",
  "7762": "97",
  "753D": "98",
  "7523": "99",
  "7763": "100",
  "7764": "101",
  "7765": "102",
  "7766": "103",
  "7671": "104",
  "7767": "105",
  "7557": "106",
  "7546": "107",
  "767C": "108",
  "777A": "109",
  "7672": "110",
  "777B": "111",
  "7564": "112",
  "763F": "113",
  "777C": "114",
  "777D": "115",
  "7659": "116",
  "7759": "117",
  "775A": "118",
  "7673": "119",
  "7674": "120",
  "7768": "121",
  "7558": "122",
  "777E": "123",
  "7675": "124",
  "756A": "125",
  "7821": "126",
  "7771": "127",
  "7772": "128",
  "7676": "129",
  "7822": "130",
  "7769": "131",
  "775B": "132",
  "7629": "133",
  "763C": "134",
  "7823": "135",
  "775C": "136",
  "776A": "137",
  "7677": "138",
  "7824": "139",
  "765A": "140",
  "765B": "141",
  "776B": "142",
  "7559": "143",
  "762A": "144",
  "7678": "145",
  "7565": "146",
  "776C": "147",
  "756B": "148",
  "755A": "149",
  "7825": "150",
  "7830": "151",
  "7826": "152",
  "7831": "153",
  "7832": "154",
  "7679": "155",
  "7566": "156",
  "776D": "157",
  "755B": "158",
  "7773": "159",
  "757D": "160",
  "7827": "161",
  "7828": "162",
  "765C": "163",
  "7829": "164",
  "767A": "165",
  "767B": "166",
  "7547": "167",
  "756C": "168",
  "756D": "169",
  "7623": "170",
  "782A": "171",
  "756E": "172",
  "7536": "176",
  "7537": "177",
  "7538": "178",
  "7539": "179",
  "767D": "180",
  "767E": "181",
  "7721": "182",
  "7722": "183",
  "7723": "184",
  "7724": "185",
  "7725": "186",
  "7726": "187",
  "7727": "188",
  "7728": "189",
  "7522": "190",
  "753E": "191",
  "7548": "192",
  "7549": "193",
  "754A": "194",
  "754B": "195",
  "754C": "196",
  "754D": "197",
  "754E": "198",
  "754F": "199",
  "7550": "200",
  "7551": "201",
  "7552": "202",
  "7553": "203",
  "7554": "204",
  "755C": "205",
  "755D": "206",
  "755E": "207",
  "755F": "208",
  "7560": "209",
  "7561": "210",
  "7562": "211",
  "7563": "212",
  "776E": "213",
  "776F": "214",
  "7567": "215",
  "7568": "216",
  "7569": "217",
  "7524": "218",
  "756F": "219",
  "7570": "220",
  "7571": "221",
  "7572": "222",
  "7526": "223",
  "7575": "224",
  "7576": "225",
  "7577": "226",
  "7578": "227",
  "7579": "228",
  "7527": "229",
  "7528": "230",
  "757E": "231",
  "7621": "232",
  "7622": "233",
  "7624": "234",
  "7625": "235",
  "7626": "236",
  "7627": "237",
  "7628": "238",
  "762B": "239",
  "762C": "240",
  "762D": "241",
  "762E": "242",
  "762F": "243",
  "7630": "244",
  "7631": "245",
  "7529": "246",
  "7632": "247",
  "7633": "248",
  "7634": "249",
  "7635": "250",
  "7636": "251",
  "7637": "252",
  "7638": "253",
  "7639": "254",
  "763D": "255",
  "763E": "256",
  "752A": "257",
  "752B": "258",
  "752C": "259",
  "752D": "260",
  "752E": "261",
  "7640": "262",
  "7641": "263",
  "7642": "264",
  "7530": "265",
  "7531": "266",
  "7532": "267",
  "7533": "268",
  "7534": "269",
  "7643": "270",
  "7644": "271",
  "7645": "272",
  "7646": "273",
  "7647": "274",
  "7648": "275",
  "7649": "276",
  "764A": "277",
  "764B": "278",
  "764C": "279",
  "764D": "280",
  "764E": "281",
  "764F": "282",
  "7650": "283",
  "7651": "284",
  "7652": "285",
  "7653": "286",
  "7654": "287",
  "765D": "288",
  "765E": "289",
  "765F": "290",
  "7660": "291",
  "7661": "292",
  "7662": "293",
  "7663": "294",
  "7664": "295",
  "7665": "296",
  "7666": "297",
  "7774": "298",
  "7775": "299",
  "7667": "300",
  "7668": "301",
  "7669": "302",
  "766A": "303",
  "766B": "304",
  "7837": "305",
  "7838": "306",
  "7839": "307",
  "783A": "308",
  "783B": "309",
  "783C": "310",
  "783D": "311",
  "783E": "312",
  "783F": "313",
  "7840": "314",
  "7841": "315",
  "7842": "316",
  "7843": "317",
  "7844": "318",
  "7845": "319",
  "7846": "320",
  "7847": "321",
  "7848": "322",
  "7849": "323",
  "784A": "324",
  "784B": "325",
  "784C": "326",
  "784D": "327",
  "784E": "328",
  "784F": "329",
  "7850": "330",
  "7851": "331",
  "7852": "332",
  "7853": "333",
  "7867": "334",
  "7868": "335",
  "7869": "336",
  "786A": "337",
  "786B": "338",
  "786C": "339",
  "786D": "340",
  "786E": "341",
  "786F": "342",
  "7870": "343",
  "7871": "344",
  "7872": "345",
  "7873": "346",
  "7874": "347",
  "7875": "348",
  "7876": "349",
  "7877": "350",
  "7878": "351",
  "7879": "352",
  "787A": "353",
  "787B": "354",
  "787C": "355",
  "787D": "356",
  "787E": "357",
  "7921": "358",
  "7922": "359",
  "7923": "360",
  "7924": "361",
  "7925": "362",
  "7926": "363",
  "7927": "364",
  "7928": "365",
  "7929": "366",
  "792A": "367",
  "792B": "368",
  "792C": "369",
  "792D": "370",
  "792E": "371",
  "792F": "372",
  "7930": "373",
  "7931": "374",
  "7932": "375",
  "7933": "376",
  "7934": "377",
  "7935": "378",
  "7936": "379",
  "7937": "380",
  "7938": "381",
  "7939": "382",
  "793A": "383",
  "793B": "384",
  "793C": "385",
  "793D": "386",
  "793E": "387",
  "793F": "388",
  "7940": "389",
  "7941": "390",
  "7942": "391",
  "7943": "392",
  "7944": "393",
  "7945": "394",
  "7946": "395",
  "7947": "396",
  "7948": "397",
  "7949": "398",
  "794A": "399",
  "794B": "400",
  "794C": "401",
  "794D": "402",
  "794E": "403",
  "794F": "404",
  "7950": "405",
  "7951": "406",
  "7952": "407",
  "7953": "408",
  "7954": "409",
  "7955": "410",
  "7956": "411",
  "7957": "412",
  "7958": "413",
  "7959": "414",
  "795A": "415",
  "795B": "416",
  "795C": "417",
  "795D": "418",
  "795E": "419",
  "795F": "420",
  "7960": "421",
  "7961": "422",
  "7962": "423",
  "7963": "424",
  "7964": "425",
  "7965": "426",
  "7966": "427",
  "7967": "428",
  "7968": "429",
  "7969": "430",
  "796A": "431",
  "796B": "432",
  "796C": "433",
  "796D": "434",
  "796E": "435",
  "796F": "436",
  "7970": "437",
  "7971": "438",
  "7972": "439",
  "7973": "440",
  "7974": "441",
  "7975": "442",
  "7976": "443",
  "7977": "444",
  "7978": "445",
  "7979": "446",
  "797A": "447",
  "797B": "448",
  "797C": "449",
  "797D": "450",
  "797E": "451",
  "7A21": "452",
  "7A22": "453",
  "7A23": "454",
  "7A24": "455",
  "7A25": "456",
  "7A26": "457",
  "7A27": "458",
  "7A28": "459",
  "7A29": "460",
  "7A2A": "461",
  "7A2B": "462",
  "7A2C": "463",
  "7A2D": "464",
  "7A2E": "465",
  "7A2F": "466",
  "7A30": "467",
  "7A31": "468",
  "7A32": "469",
  "7A33": "470",
  "7A34": "471",
  "7A35": "472",
  "7A36": "473",
  "7A37": "474",
  "7A38": "475",
  "7A39": "476",
  "7A3A": "477",
  "7A3B": "478",
  "7A3C": "479",
  "7A3D": "480",
  "7A3E": "481",
  "7A3F": "482",
  "7A40": "483",
  "7A41": "484",
  "7A42": "485",
  "7A43": "486",
  "7A44": "487",
  "7A45": "488",
  "7A46": "489",
  "7A47": "490",
  "7A48": "491",
  "7A49": "492",
  "7A4A": "493",
  "7A4B": "494",
  "7A4C": "495",
  "7A4D": "496",
  "7A4E": "497",
  "7A4F": "498",
  "7A50": "499",
  "7854": "500",
  "7855": "501",
  "7856": "502",
  "7857": "503",
  "7858": "504",
  "7859": "505",
  "785A": "506",
  "785B": "507",
  "785C": "508",
  "785D": "509",
  "785E": "510",
  "785F": "511",
  "7860": "512",
  "7861": "513",
  "7862": "514",
  "7863": "515",
  "7864": "516",
  "7865": "517",
  "7866": "518",
  "7A51": "700",
  "7A52": "701",
  "7A53": "702",
  "7A54": "703",
  "7A55": "704",
  "7A56": "705",
  "7A57": "706",
  "7A58": "707",
  "7A59": "708",
  "7A5A": "709",
  "7A5B": "710",
  "7A5C": "711",
  "7A5D": "712",
  "7A5E": "713",
  "7A5F": "714",
  "7A60": "715",
  "7A61": "716",
  "7A62": "717",
  "7A63": "718",
  "7A64": "719",
  "7A65": "720",
  "7A66": "721",
  "7A67": "722",
  "7A68": "723",
  "7A69": "724",
  "7A6A": "725",
  "7A6B": "726",
  "7A6C": "727",
  "7A6D": "728",
  "7A6E": "729",
  "7A6F": "730",
  "7A70": "731",
  "7A71": "732",
  "7A72": "733",
  "7A73": "734",
  "7A74": "735",
  "7A75": "736",
  "7A76": "737",
  "7A77": "738",
  "7A78": "739",
  "7A79": "740",
  "7A7A": "741",
  "7A7B": "742",
  "7A7C": "743",
  "7A7D": "744",
  "7A7E": "745",
  "7B21": "746",
  "7B22": "747",
  "7B23": "748",
  "7B24": "749",
  "7B25": "750",
  "7B26": "751",
  "7B27": "752",
  "7B28": "753",
  "7B29": "754",
  "7B2A": "755",
  "7B2B": "756",
  "7B2C": "757",
  "7B2D": "758",
  "7B2E": "759",
  "7B2F": "760",
  "7B30": "761",
  "7B31": "762",
  "7B32": "763",
  "7B33": "764",
  "7B34": "765",
  "7B35": "766",
  "7B36": "767",
  "7B37": "768",
  "7B38": "769",
  "7B39": "770",
  "7B3A": "771",
  "7B3B": "772",
  "7B3C": "773",
  "7B3D": "774",
  "7B3E": "775",
  "7B3F": "776",
  "7B40": "777",
  "7B41": "778",
  "7B42": "779",
  "7B43": "780",
  "7B44": "781",
  "7B45": "782",
  "7B46": "783",
  "7B47": "784",
  "7B48": "785",
  "7B49": "786",
  "7B4A": "787",
  "7B4B": "788",
  "7B4C": "789",
  "7B4D": "790",
  "7B4E": "791",
  "7B4F": "792",
  "7B50": "793",
  "7B51": "794",
  "7B52": "795",
  "7B53": "796",
  "7B54": "797",
  "7B55": "798",
  "7B56": "799",
  "7B57": "800",
  "7B58": "801",
  "7B59": "802",
  "7B5A": "803",
  "7B5B": "804",
  "7B5C": "805",
  "7B5D": "806",
  "7B5E": "807",
  "7B5F": "808",
  "7B60": "809",
  "7B61": "810",
  "7B62": "811",
  "7B63": "812",
  "7B64": "813",
  "7B65": "814",
  "7B66": "815",
  "7B67": "816",
  "7B68": "817",
  "7B69": "818",
  "7B6A": "819",
  "7B6B": "820",
  "7B6C": "821",
  "7B6D": "822"
};
