var EmojiPrint = {
  onLoad: function() {
    // initialization code
    EmojiPrint.initialized = true;
    EmojiPrint.messagePane = document.getElementById('messagepane');
    EmojiPrint.messagePane.addEventListener("load", EmojiPrint.convert, true);
  },
  stripHeaderFromMessage: function( message ){
    var ret = message;
    return ret;
  },
  getContentFromMessageURI: function(uri){
    var messageService = messenger.messageServiceFromURI(uri);
    var messageStream = Components.classes["@mozilla.org/network/sync-stream-listener;1"].createInstance().QueryInterface(Components.interfaces.nsIInputStream);
    var inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance().QueryInterface(Components.interfaces.nsIScriptableInputStream);
    inputStream.init(messageStream);
    messageService.streamMessage(uri, messageStream, {}, null, false, null);

    var body = "";
    inputStream.available();
    while (inputStream.available()) {
      body = body + inputStream.read(512);
    }
    messageStream.close();
    inputStream.close();
    return EmojiPrint.stripHeaderFromMessage(body);
  },
  convert: function() {
    var carrier = EmojiPrint.detectCarrier();
    if( !carrier ){
      return;
    }
    var content = EmojiPrint.getMessageContent(carrier);
    var messageDocument = EmojiPrint.messagePane.contentDocument;
    messageDocument.body.innerHTML = '<div style="line-height: 18px;">'+content+'</div>';
  },
  getMessageContent: function(carrier) {
    var messages = GetSelectedMessages();
    if( !messages ) {
      return;
    }
    var source = EmojiPrint.getContentFromMessageURI(messages[0]);
    var mail = new EmojiPrint.Mail(source);
    var charset = mail.charset.toLowerCase();
    if( carrier.filter ){
      mail.body = carrier.filter(mail.body);
    }
    if( EmojiPrint.Converter[charset] && carrier[charset] ){
      var content = EmojiPrint.Converter[charset]( mail.body, carrier[charset] );
    }
    var uconv = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
                    createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    uconv.charset = mail.charset;
    content = uconv.ConvertToUnicode(content);
    return content;
  },
  detectCarrier: function() {
    var messages = GetSelectedMessages();
    if( !messages ) {
      return;
    }
    var hdr = messenger.msgHdrFromURI(messages[0]);
    var author = hdr.author;
    if( author.match(/\<([^\>]+)\>/) ){
      author = RegExp.$1;
    }
    if( author.match(/\@ezweb\.ne\.jp$/) ){
      return EmojiPrint.Carrier.au;
    }
    if( author.match(/\@docomo\.ne\.jp$/) ){
      return EmojiPrint.Carrier.docomo;
    }
    if( author.match(/\@softbank\.ne\.jp$/) ||
        author.match(/\@(\w+\.)?vodafone\.ne\.jp$/) ){
      return EmojiPrint.Carrier.softbank;
    }
    if( author.match(/\@pdx\.ne\.jp$/) ){
      return EmojiPrint.Carrier.willcom;
    }
    return;
  }
};

window.addEventListener("load", function(e) { EmojiPrint.onLoad(e); }, false);
